<?php

/* University of Illinois/NCSA Open Source License for zappassc.php.

 Copyright (c) 2009/11 Jim Champ/Surrey County Council
 All rights reserved.
 Developed by: 		Jim Champ
 www.devboats.co.uk/zappassc
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal with the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimers.

 Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and the following disclaimers
 in the documentation and/or other materials provided with the
 distribution.

 Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
 or promote products derived from this Software without specific prior
 written permission.
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.*/

// This is for versions of PHP below 5.1 which don't include the fputcsv function
// If you wll never use versions of PHP below 5.1 you can delete it

// **** Start fputcsv code ****

if (!function_exists('fputcsv')) {
	function fputcsv(&$handle, $fields = array(), $delimiter = ',', $enclosure = '"') {
		// this function is example code from php documentation site
		// contributed by jon+dontspamme at phpsitesolutions dot com
		//  30-Jul-2008 05:44
		//it is licensed under the followimg creative commons license
		//  http://uk.php.net/manual/en/cc.license.php
		// the rest of the code is licensed under University of illinois/NCSA.

		// Sanity Check
		if (!is_resource($handle)) {
			trigger_error('fputcsv() expects parameter 1 to be resource, ' .
			gettype($handle) . ' given', E_USER_WARNING);
			return false;
		}

		if ($delimiter!=NULL) {
			if( strlen($delimiter) < 1 ) {
				trigger_error('delimiter must be a character', E_USER_WARNING);
				return false;
			}elseif( strlen($delimiter) > 1 ) {
				trigger_error('delimiter must be a single character', E_USER_NOTICE);
			}

			/* use first character from string */
			$delimiter = $delimiter[0];
		}

		if( $enclosure!=NULL ) {
			if( strlen($enclosure) < 1 ) {
				trigger_error('enclosure must be a character', E_USER_WARNING);
				return false;
			}elseif( strlen($enclosure) > 1 ) {
				trigger_error('enclosure must be a single character', E_USER_NOTICE);
			}

			/* use first character from string */
			$enclosure = $enclosure[0];
		}

		$i = 0;
		$csvline = '';
		$escape_char = '\\';
		$field_cnt = count($fields);
		$enc_is_quote = in_array($enclosure, array('"',"'"));
		reset($fields);

		foreach( $fields AS $field ) {

			/* enclose a field that contains a delimiter, an enclosure character, or a newline */
			if( is_string($field) && (
			strpos($field, $delimiter)!==false ||
			strpos($field, $enclosure)!==false ||
			strpos($field, $escape_char)!==false ||
			strpos($field, "\n")!==false ||
			strpos($field, "\r")!==false ||
			strpos($field, "\t")!==false ||
			strpos($field, ' ')!==false ) ) {

				$field_len = strlen($field);
				$escaped = 0;

				$csvline .= $enclosure;
				for( $ch = 0; $ch < $field_len; $ch++ )    {
					if( $field[$ch] == $escape_char && $field[$ch+1] == $enclosure && $enc_is_quote ) {
						continue;
					}elseif( $field[$ch] == $escape_char ) {
						$escaped = 1;
					}elseif( !$escaped && $field[$ch] == $enclosure ) {
						$csvline .= $enclosure;
					}else{
						$escaped = 0;
					}
					$csvline .= $field[$ch];
				}
				$csvline .= $enclosure;
			} else {
				$csvline .= $field;
			}

			if( $i++ != $field_cnt ) {
				$csvline .= $delimiter;
			}
		}

		$csvline .= "\n";

		return fwrite($handle, $csvline);
	}
}

// **** End of fputcsv code ****



// the program produces an array which then needs to be sent as a download. 
// that means that when that module is called the download headers need to 
// be the first thing sent to the browser, so must be the result of a
// post command. passing a huge array across in a post command was ugly 
// and probably has security implications, so instead we use this temp
// file. The whole utility is maybe more vulnerable to misbehavious than some
// but in any case I can't imagine wanting to ezpose the directory publically
// anyway.

// **** OES/Netware change required ****

// For OES you need a path to tmp for the download file
// There will be lots of potential security gotchas in OES, depending on what level of security you 
// have set in the browser and with php. in Netware you don't need to bother: it will default to sys:php5.
// If you do want a path in Netware of course you will need to use Netware syntax for the path: sys:/tmp or whatever


//$fptempfile = "/tmp/~tmpfpdn.txt";  // This line for OES
$fptempfile = "~tmpfpdn.txt";     // This line for Netware

// string used to identify a download call. Can be anything.
$downloadcmd = "dhgtr71%df";


// start by querying the post variables to determine which code path to use

if (@$_POST['ldap_id'] > "" ) {
	// newer systems support the _post system for posted variable
	// older ones http_post_vars so we test for both...
	pageHeader();
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$ldap_root=$_POST['ldap_root'];
} else {
	if (@$HTTP_POST_VARS['ldap_id'] > "" ) {
		pageHeader();
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		$ldap_root=$HTTP_POST_VARS['ldap_root'];
	} else {
		if (@$_POST['fdownload'] == $downloadcmd ) {
			downloadData();
			exit;
		} else {
			if (@$HTTP_POST_VARS['fdownload']  == $downloadcmd ) {
				downloadData();
				exit;
			} else {
				// if we haven't got any ldap id set go to the authentication form
				pageHeader();
				printintro();
				closedocument();
				exit;
			}
		}
	}
}


echo "<p>Connection to LDAP server";
$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!
if (strlen($ldap_pw) <1){
	// if the pw is unset set nonsense in the field...
	// I've spotted some odd behaviour with password apparently kept in cache which is
	// dubious security wise. This ensures it has to be set every time 
	$ldap_pw = "gdhfr76~x8**";
}
if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " succeeded<br>\n";
	// we have now made an LDAP connection
} else {
	echo " failed.</p><h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (cn=username,ou=unit,o=org) rather than NDS syntax for the user id.</p>\n";
	closedocument();
	exit;
}

//First we search for all org units and get app associations...
echo "Searching for OUs under $ldap_root.<br>\n";

$ldap_sr = "objectClass=organizationalUnit";
$sr=@ldap_search($ds, $ldap_root, $ldap_sr, array(ou, appAssociations) );

$ouEntry = @ldap_first_entry($ds, $sr);

if (@ldap_count_entries($ds, $sr) <1){
	//No org units have been found....
	//maybe its a person...
	//split up the field
	$dpos=strpos($ldap_root,",");
	$userDN = $ldap_root;
	$userCN = substr($userDN,0,$dpos);
	$userOU = substr($userDN,$dpos+1);

	//and do a query for a matching Person...
	$ldap_root = $userOU;
	$ldap_sr = "(&(objectClass=Person)($userCN))";
	$sr=@ldap_search($ds, $ldap_root, $ldap_sr, array(cn, givenName, sn, mail,eMailAddress,telephoneNumber, groupMembership, loginDisabled, loginTime, appAssociations) );
	$usrEntry = @ldap_first_entry($ds, $sr);

	if (@ldap_count_entries($ds, $sr) !=1){
		echo "</p><h3>No Organisation Units or Users Found</h3>\n";
		echo "<p>No OUs were found under context $ldap_root or it is not a valid user. This context/user doesn't exist or no organisation units \n";
		echo "exist within it. Use back to go back to the form and renter the Working OU/Context. Ensure that you \n";
		echo "have entered the OU in correct typeful ldap syntax - commas, not full stops.</p>\n";
		closedocument();
		exit;
	} else {
		//call the sub routine to process an individual user
		IndividualUserOutput($usrEntry, $userCN, $userOU);
	}
} else {
	// we call the sub to process all users in an OU
	OrganizationalUnitOutput($ouEntry);
}

// whether by user or by OU we gathered all the data in outputArr 
// so we deal with it the same way
echo "<br>\nPreparing data download</p>";
CreateCSVOutputFile($outputArray,$outputCtr);

// optionally you could output the data to html form, not csv download 
//but beware, the tables can be monstrous, and you'll surely want the data in a
//spreadsheet anyway. This was abandoned speedily after user complaints!
//WriteHtmlOutputTableToScreen($outputArray,$outputCtr);

// and end
closedocument();
exit;


function printintro() {
	// this produces the form to fill in when there's not a ldap_id in the post vars.
	$a = <<<HTMLFORM
<center>
<FORM METHOD="POST" ACTION="zappassc.php" ENCTYPE="x-www-form-urlencoded">
<TABLE class="main" CELLPADDING="2" CELLSPACING="2">
<TR>
    <TD class="maintdpos">LDAP Admin User ID: </TD>
    <TD  class="maintdpos"><INPUT TYPE="text" NAME="ldap_id" SIZE="50" MAXLENGTH="80"></TD>
</TR>
<TR>
    <TD  class="maintdpos">LDAP Password:</TD>
    <TD  class="maintdpos"><INPUT TYPE="password" NAME="ldap_pw" SIZE="50" MAXLENGTH="50"></TD>
</TR>
<TR>
    <TD  class="maintdpos">LDAP Server:</TD>
    <TD  class="maintdpos"><INPUT TYPE="text" NAME="ldap_server" VALUE="sccnthfa5.surreycc.gov.uk" SIZE="50" MAXLENGTH="50"></TD>
</TR>
<!--<TR>
     <TD colspan="2">
	<HR>
     </TD>
</TR>-->
<TR>
    <TD  class="maintdpos">Context or User:</TD>
    <TD  class="maintdpos"><INPUT TYPE="text" NAME="ldap_root" VALUE="ou=imt,ou=ch,ou=nor,ou=nth,o=surreycc" SIZE="50" MAXLENGTH="80"></TD>
</TR>

<!-- <TR>
     <TD colspan="2">
	<HR>
     </TD>
</TR>-->

<TR>
    <TD class="maintdpos"><INPUT TYPE="submit" VALUE="Post Details"></TD>
   <TD class="maintdpos"><INPUT TYPE="reset" VALUE="Clear Form"></TD>
</TR>
</TABLE>
</center>
<H3>Notes and Help</h3>
<p>LDAP Admin user id must be in typeful LDAP format ie <CODE>cn=adminuser,o=organisation</CODE>.
The delimiters must be commas and not full stops.<p>
<p>LDAP server. The best servers to use are SCCNTHFA5 or SCCNTHFA6, depending on whether you are
working in the NTH (5) or STH (6)areas of the NDS Tree.</p>
<p>Context or User must also be in typeful LDAP format, so
<CODE>ou=dept,ou=building,ou=town,o=organisation</CODE> or
<CODE>cn=username,ou=dept,ou=building,ou=town,o=organisation</CODE>. </p>

<p>zappassc.php is &copy; Surrey County Council 2010. </p>

HTMLFORM;
	echo $a;
}

//this could be used if you want to accept non-ldap dformat input
//may be a useful enhancement...
function EdirtoLdap($DN) {
	//echo "<pre>Edirtoldap function</pre>";
	// OK here we have a Netware format Context
	// ie fred.bill.adrian.org
	// we want to convert it to LDAP format eg
	// cn=fred,ou=bill,ou=adrian,o=org
	$last = strrchr($DN, ".");
	$DN = str_replace($last,",O=".substr($last,1),$DN);
	$DN = str_replace(".",",OU=",$DN);
	return "OU=" . $DN;
}

function closedocument(){
	//any page foooter or the like goes here...
	echo "</body>\n</html>\n";
}

function GetOuData($ouEntry) {
	//get the data for an OU(!)
	//$ouEntry is the result of an Ldapgetfirstentry call
	global $ds;
	global $appArray;
	global $ouArray;

	$ouAttrs = @ldap_get_attributes($ds,$ouEntry);
	$udn = @ldap_get_dn($ds,$ouEntry);

	$cnctr = 0;
	while($cnctr < @$ouAttrs["appAssociations"]["count"]) {
		// we stuff all the app associations in the apps array
		// this app array stores all app associations found in an array without (many) duplicates 
		// this is for efficiency
		$appArray[@$ouAttrs["appAssociations"][$cnctr]] = "";
		$ouArray[$udn][$cnctr] = @$ouAttrs["appAssociations"][$cnctr];
		$cnctr++;
		//these echo " ." are for some screen updating. Its of limited value in the
		//web format, so is commented out, but might be nice if you desire
		//to convert this to a console app 
		// echo " .";
	}
}

function GetUserData($userEntry) {
	//similarly here we process users and store their 
	//groups and apps
	global $ds;
	global $userArray;
	global $groupArray;
	global $appArray;

	$userAttrs = @ldap_get_attributes($ds,$userEntry);
	$udn = @ldap_get_dn($ds,$userEntry) . "\t";

	$cnctr = 0;
	while($cnctr < @$userAttrs["groupMembership"]["count"])	{
		// we stuff the list of groups in grouparray
		// doubtless many groups will be stuffed in multiple times
		// at this stage there's nothing of any consequence *in* the array...
		$groupArray[@$userAttrs["groupMembership"][$cnctr]] = "";
		$cnctr ++;
	}

	$cnctr = 0;
	while($cnctr < @$userAttrs["appAssociations"]["count"]){
		// And here we get the list of applications and bang it in app array, similarly this will be multiply
		// added, but the app association being the index there are no actual duplicates
		// in the array. It seems far to much trouble to query for whether the app is 
		//already there...
		$appArray[@$userAttrs["appAssociations"][$cnctr]] = "";
		$cnctr ++;
		// echo " .";
	}
}

function ProcessGroupData() {
	global $ds;
	global $groupArray;
	global $appArray;

	foreach ($groupArray as $groupDN => $groupValue) {
		// so here we are with groupDN containing each successive DN...
		// so we want to split this up into cn and the rest of the DN
		//which will be the LDAP root for our search...

		$dpos=strpos($groupDN,",");
		$ldap_sr = substr($groupDN,0,$dpos);
		$ldap_groupRoot = substr($groupDN,$dpos+1);
		$sr=@ldap_search($ds, $ldap_groupRoot, $ldap_sr, array(cn, member, owner, description, appAssociations) );

		$groupAppEntry = @ldap_first_entry($ds, $sr);
		$groupAppAttrs = @ldap_get_attributes($ds,$groupAppEntry);
		$cnctr = 0;
		while($cnctr < @$groupAppAttrs["appAssociations"]["count"]) {
			// and we stuff all the app associations in the apps array
			$appArray[@$groupAppAttrs["appAssociations"][$cnctr]] = "";
			$groupArray[$groupDN][@$groupAppAttrs["appAssociations"][$cnctr]] = @$groupAppAttrs["appAssociations"][$cnctr];
			$cnctr ++;
			// echo " .";
		}
		// echo " .";
	}

}

function GetAppCaptions(){
	global $ds;
	global $appArray;

	foreach ($appArray as $appDN => $appValue) {
		// so here we are with appDN containing each successive DN...
		// so we want to split this up into cn and the rest of the DN
		// which will be the LDAP root for our search...
		// note how appDN has various peculiar stuff with #on the end
		// the hash is left on the DN because that's the association format
		// we will format it when we need it gone...

		$dpos=strpos($appDN,",");
		$ldap_sr = substr($appDN,0,$dpos);
		$ldap_appRoot = substr($appDN,$dpos+1);
		$hpos=strpos($ldap_appRoot,"#");
		$ldap_appRoot = substr($ldap_appRoot,0,$hpos);

		$sr=@ldap_search($ds, $ldap_appRoot, $ldap_sr, array(cn, appCaption) );
		$AppDetailEntry = @ldap_first_entry($ds, $sr);
		$AppDetailAttrs = @ldap_get_attributes($ds,$AppDetailEntry);
		$appArray[$appDN] = @$AppDetailAttrs["appCaption"][0];
		// echo " .";
	}
}


function DoFinalProcessing($userEntry){
	// in this sub we pull the data from all the arrays together and
	//constrcut a final table of data in outputArray
	global $ds;
	global $outputCtr;
	global $outputArray;
	global $appArray;
	global $ouArray;
	global $groupArray;

	// we get the user's full name here...
	$userAttrs = @ldap_get_attributes($ds,$userEntry);
	$udn = @ldap_get_dn($ds,$userEntry);
	$FullName = @$userAttrs["givenName"][0] . " " .  @$userAttrs["sn"][0];

	$cnctr = 0;
	//process all their group memberships
	while($cnctr < @$userAttrs["groupMembership"]["count"]){
		if(count($groupArray[@$userAttrs["groupMembership"][$cnctr]])> 1){
			foreach ($groupArray[@$userAttrs["groupMembership"][$cnctr]] as $groupOvalue) {
				$outputArray[$outputCtr]["dn"] = $udn;
				$outputArray[$outputCtr]["fullname"] = $FullName;
				//here the use of app array for storing appdetails comes into play
				$outputArray[$outputCtr]["appCaption"] = $appArray[@$groupOvalue];
				$outputArray[$outputCtr]["appDN"] = @$groupOvalue;
				$outputArray[$outputCtr]["source"] = "Group Association";
				$outputArray[$outputCtr]["sourcedn"] =  @$userAttrs["groupMembership"][$cnctr];
				$outputCtr = $outputCtr +1;
			}
		}
		$cnctr ++;
	}
	// echo " .";

	$cnctr = 0;
	// and their app associations
	while($cnctr < @$userAttrs["appAssociations"]["count"]){
		$outputArray[$outputCtr]["dn"] = $udn;
		$outputArray[$outputCtr]["fullname"] = $FullName;
		$outputArray[$outputCtr]["appCaption"] = $appArray[@$userAttrs["appAssociations"][$cnctr]];
		$outputArray[$outputCtr]["appDN"] = @$userAttrs["appAssociations"][$cnctr];
		$outputArray[$outputCtr]["source"] = "User Association";
		$outputArray[$outputCtr]["sourcedn"] =  @$userAttrs["appAssociations"][$cnctr];
		$cnctr ++;
		$outputCtr = $outputCtr +1;
	}
	// echo " .";

	//and now the OU...
	//only the parent OU is used here. The exercise of dealing with subordinates, should
	//you inherit app objects lower, is set for the advanced student
	//hardly rocket science...
	$dpos=strpos($udn,",");
	$user_ou = substr($udn,$dpos+1);
	$cnctr = 0;
	while ($cnctr < count($ouArray[$user_ou])) {
		//echo "ouDN for app " . $ouArray[$user_ou][$cnctr] . "\n";
		$outputArray[$outputCtr]["dn"] = $udn;
		$outputArray[$outputCtr]["fullname"] = $FullName;
		$outputArray[$outputCtr]["appCaption"] = $appArray[$ouArray[$user_ou][$cnctr]];
		$outputArray[$outputCtr]["appDN"] = $ouArray[$user_ou][$cnctr];
		$outputArray[$outputCtr]["source"] = "OU Association: ";
		$outputArray[$outputCtr]["sourcedn"] =   $user_ou;
		$cnctr = $cnctr+1;
		$outputCtr = $outputCtr +1;

	}
	// echo " .";
}

function CreateCSVOutputFile($outputArray,$outputCtr) {
	global $fptempfile;
	global $downloadcmd;
	//delete the old output file if it exists...
	@unlink($fptempfile);
	//open
	$fhandle = fopen($fptempfile, "wb");
    if ($fhandle === false) {
     	echo "<p>output file not available.</p>\n";
     	echo "<p>Script terminated.</p>\n\n";
     	exit();
     
    } else {
     	echo "<p>available - continuing script.</p>\n";
     
    }
	//this one is really pretty self explanatory!
	$cnctr = 0;
	//create header row and export
	$oline = array("User DN","User Name","App Title","App DN","Association","Association DN");
	fputcsv($fhandle,$oline);

	while($cnctr < $outputCtr){
		//iterate through 
		$hpos=@strpos(@$outputArray[$cnctr]["appDN"],"#");
		$format_appdn = @substr(@$outputArray[$cnctr]["appDN"],0,$hpos);
		$oline=array(@$outputArray[$cnctr]["dn"],@$outputArray[$cnctr]["fullname"],@$outputArray[$cnctr]["appCaption"],$format_appdn,@$outputArray[$cnctr]["source"],@$outputArray[$cnctr]["sourcedn"]);
		fputcsv($fhandle,$oline);
		$cnctr ++;
	}

	$r=fclose($fhandle);
	
	//and finally construct a button to download the file...
	echo "<p><FORM METHOD=\"POST\" ACTION=\"zappassc.php\" ENCTYPE=\"x-www-form-urlencoded\">";
	echo "<INPUT TYPE=\"hidden\" NAME=\"fdownload\" VALUE=\"$downloadcmd\" >";
	echo "<INPUT TYPE=\"submit\" VALUE=\"Download Output\"></TD>";
	echo "</FORM></p>";
	//echo $outputCsv;

}

function WriteHtmlOutputTableToScreen($outputArray,$outputCtr) {
	//this one is not referenced, but its the baby you should use if you want screen output
	// beware, there can be huge amounts of screen output. Its 3000 lines just for
	// our IT department!
	$cnctr = 0;
	echo "</p>";
	echo "<table>";
	echo "<tr>\n";
	echo "\t<th>User DN</th>\n";
	echo "\t<th>User Name</th>\n";
	echo "\t<th>App Title</th>\n";
	echo "\t<th>App DN</th>\n";
	echo "\t<th>Association</th>\n";
	echo "\t<th>Association DN</th>\n";
	echo "</tr>\n";

	while($cnctr < $outputCtr){
		echo "<tr>";
		echo "\t<td>" . @$outputArray[$cnctr]["dn"] . "</td>\n";
		echo "\t<td>" . @$outputArray[$cnctr]["fullname"] . "</td>\n";
		echo "\t<td>" . @$outputArray[$cnctr]["appCaption"] . "</td>\n";
		$hpos=@strpos(@$outputArray[$cnctr]["appDN"],"#");
		$format_appdn = @substr(@$outputArray[$cnctr]["appDN"],0,$hpos);
		echo "\t<td>" . $format_appdn . "</td>\n";
		echo "\t<td>" . @$outputArray[$cnctr]["source"] . "</td>\n";
		echo "\t<td>" . @$outputArray[$cnctr]["sourcedn"] . "</td>\n";
		echo "</tr>";
		$cnctr ++;
	}
	echo "</table>";
}

Function OrganizationalUnitOutput($ouEntry) {
	global $appArray;
	global $ds;
	global $groupArray;
	global $ouArray;
	global $outputArray;
	global $outputCtr;
	global $userArray;
	global $ldap_root;

	//this is the main function for exporting data for all users in an OU

	while ($ouEntry) {
		// populate data arrays from/for each org unit in turn
		GetOuData($ouEntry) ;
		$ouEntry = @ldap_next_entry($ds, $ouEntry);
		// echo " .";
	}

	// now we search for all person objects and get app associations and group memberships
	echo "<br>\nSearching for Users under $ldap_root.";

	$ldap_sr = "objectClass=Person";
	$sr=@ldap_search($ds, $ldap_root, $ldap_sr, array(cn, givenName, sn, mail,eMailAddress,telephoneNumber, groupMembership, loginDisabled, loginTime, appAssociations) );

	$userEntry = @ldap_first_entry($ds, $sr);
	//echo  @ldap_count_entries($ds, $sr) . " user directory entries returned.\n";
	while ($userEntry) {
		GetUserData($userEntry);
		$userEntry = @ldap_next_entry($ds, $userEntry);
		// echo " .";
	}

	// so at this point we have...
	//ouArray containing a list of OUs
	//userArray containing a list of users
	//groupArray containing a list of groups
	//appArray containing a list of apps
	//it's entirely possible that groupArray and appArray contain items outside the
	//base OU for the OU search...
	//and appArray doesn't yet contain all possible app objects because we
	//are yet to query the various groups for their associated apps...


	// so next lets iterate through the array of groups and get all the app associations in there...
	echo "<br>\nSearching for Group Details ";

	ProcessGroupData();

	//OK, next we want to populate the apps array with the application titles
	//it wants to have cn, appCaption

	echo "<br>\nSearching for Application Details ";

	GetAppCaptions();

	//OK, here we have the various arrays of detail
	//next is to get the whole damn lot in one array
	//format it
	//and produce the output
	// for each user...
	//output array is
	// userdn, appcaption, appdn (less junk), source
	// so for each user
	// output for OU
	// output for user
	// output for group memberships...

	// now we search for all person objects again, hopefully with the same results
	// this is a tad inefficient, but I'd rather not mess with very multidimensional arrays
	// because I find the resulting code rather confusing and it makes my head hurt...
	// if anyone comes up with a better solution then please supply details via
	// contacts on the home page

	echo "<br>\nFinal Search and Processing ";
	$outputCtr=0;
	$ldap_sr = "objectClass=Person";
	$sr=@ldap_search($ds, $ldap_root, $ldap_sr, array(cn, givenName, sn, mail,eMailAddress,telephoneNumber, groupMembership, loginDisabled, loginTime, appAssociations) );
	$userEntry = @ldap_first_entry($ds, $sr);

	while ($userEntry) {
		DoFinalProcessing($userEntry);
		$userEntry = @ldap_next_entry($ds, $userEntry);
	}


}

Function IndividualUserOutput($userEntry, $userCN, $userOU) {
	global $ds;
	global $appArray;
	global $groupArray;
	global $ouArray;
	global $outputArray;
	global $outputCtr;
	global $userArray;
	// this is the other major data gathering function, this time for when
	// a user has been picked... 
	//first we get the user info
	GetUserData($userEntry);

	//we re-search for org unit based on the DN of the user...
	$dpos=strpos($userOU,",");
	$ouOU = substr($userOU,0,$dpos);

	$ldap_sr = "(&(objectClass=organizationalUnit)($ouOU))";
	$sr=@ldap_search($ds, $userOU, $ldap_sr, array(ou, appAssociations) );
	$ouEntry = @ldap_first_entry($ds, $sr);

	// and get the org unit details
	GetOuData($ouEntry);

	// so next lets iterate through the array of groups and get all the app associations in there...
	echo "<br>\nSearching for Group Details ";

	ProcessGroupData();

	//OK, next we want to populate the apps array with details.
	//it wants to have cn, appCaption
	echo "<br>\nSearching for Application Details ";
	GetAppCaptions();

	//no need for the second search in this case...
	echo "<br>\nFinal Search and Processing ";
	DoFinalProcessing($userEntry);

}

function pageHeader(){
	$h= <<<HTMLHEADER
<html>
<head>

<!--
 University of Illinois/NCSA Open Source License for zappassc.php.

 Copyright (c) 2009/11 Jim Champ/Surrey County Council
 All rights reserved.
 Developed by: 		Jim Champ
 www.devboats.co.uk/zappassc
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal with the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimers.

 Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and the following disclaimers
 in the documentation and/or other materials provided with the
 distribution.

 Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
 or promote products derived from this Software without specific prior
 written permission.
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.

-->




<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>DS Application Association Report Utility</title>

HTMLHEADER;

	echo $h;
	echo "</head>\n";
	echo "<body>\n";
	echo "<div>";
	echo "<H1>DS Application Association Report Utility</H1>";

}

Function downloadData(){
	header("Content-Disposition: filename=\"zappassc.csv\"");
	header("Content-Type: application/force-download");
	header("Content-Type: application/octet-stream");
	header("Content-Type: application/download");
	header("Content-Description: File Transfer");
	global $fptempfile;
	readfile($fptempfile);
	//echo "downloadData function completed";
	//ths is the actual download of the csv file, note how you may not
	//have anything at all in front of the header statements or the
	//download is broken because php sends a default hrml header
}

?>
